package main

import (
	"os"
	"log"
)

func initLogging(logFilePath string) *os.File {
	f, err := os.OpenFile(logFilePath, os.O_RDWR | os.O_CREATE | os.O_APPEND, 0600)
	if err != nil {
		panic(err)
	}

	log.SetOutput(f)
	return f
}

func teardownLogging(f *os.File) {
	fi, err := f.Stat()
	if err != nil {
		panic(err)
	}
	if fi.Size() == 0 {
		err = os.Remove(f.Name())
		if err != nil {
			panic(err)
		}
	}
	err = f.Close()
	if err != nil {
		panic(err)
	}
}